
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by and Copyright (C) Francois Fleuret                         //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

#ifndef SIMPLE_WINDOW_H
#define SIMPLE_WINDOW_H

#include <iostream>
#include <cmath>
#include <stdlib.h>
#include <string.h>

#include <stdio.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xresource.h>
#include <X11/cursorfont.h>

class SimpleWindow {
  Display *dpy;
  Window window;
  Pixmap pixmap;
  GC gc;

protected:
  int red_mask, green_mask, blue_mask;
  int red_shift, green_shift, blue_shift;
  int width, height;

public:
  SimpleWindow(const char *name, int w, int h);
  virtual ~SimpleWindow();

  virtual int get_width();
  virtual int get_height();

  virtual void map();
  virtual void unmap();
  virtual void color(float red, float green, float blue);
  virtual void draw_point(int x, int y);
  virtual void draw_line(int x1, int y1, int x2, int y2);
  virtual void draw_circle(int x, int y, int r);
  virtual void draw_text(char *s, int x, int y);
  virtual void fill_rectangle(int x, int y, int w, int h);
  virtual void show();
  virtual void fill();
};

#endif
